#!/bin/sh
#
# @(#)MAKEDEV.ne	1.1 10/10/91 SMI/Interphase
#

PATH=/usr/ucb:/usr/bin:/usr/etc
umask 000 # want /dev/ne* to have mode 666

set -h
set -u

# Change the following number based on your "/sys/sun/conf.c"
# (In a normal installation, this will be edited automatically.)
necmaj=105

#
# makenodes: generate mknod command lines, piped to "sh"
# Usage: makenodes devname device-count block-maj char-maj

makenodes()
{
	echo $1 $2 $3 $4 | \
	/bin/awk '{ \
		unit = substr($1, 3, 1); \
		minor = unit * 8; lastm = minor + $2; \
		ascii = 97; \
		while ( minor < lastm ) { \
			printf "mknod  %s%c b %d %d\n", $1, ascii, $3, minor; \
			printf "mknod r%s%c c %d %d\n", $1, ascii, $4, minor; \
			minor++; ascii++; \
		} \
	}' | /bin/sh $SHOPS
	return $?
}


#
# devattrs:  set owner, group, and mode
# Usage: devattrs user.group mode 

devattrs()
{
	chown $1 ${3}? r${3}?
	chmod $2 ${3}? r${3}?
	return 0
}


#
# single:  creates one node; minor number is derived from name
# Usage:  single name b/c major

single()
{
	minor=`echo $1 | sed 's/.*\(.\)/\1/'`
	mknod $1 $2 $3 $minor
}


SHOPS=""

for arg
do
    case $arg in
	ne[0-7])
		single $arg c $necmaj
		;;
	-*)
		SHOPS="$SHOPS $arg"
		;;
	*)
		echo ${0}: don\'t recognize \"$arg\"
		;;
    esac
done
