#!/bin/sh
#
#	@(#)edit.sh	1.2 93/01/15 Copyright (C) 1992  Sun Microsystems, Inc
#
# Script to call the individual editing scripts for the
# automatic installation of the Network Coprocessor.
#

WS='[ 	][ 	]*'		# required white space for pattern matches
OWS='[ 	]*'			# optional white space

export WS OWS			# export these to subsidiary scripts

DIR=$INSTALL_DIR
cd $DIR

STATUS=0

#
# Shell function to execute a file if it exists
#

Execute () {
	if [ -f $1 ] ; then
		if [ ! -x $1 ] ; then
			chmod +x $1
		fi
		./$1
		STATUS=`expr $STATUS \| $?`
	else
		echo "Installation error: file $DIR/$1 not found."
		echo "This indicates that the CD distribution is incorrect."
		STATUS=1
	fi
}

#
# Ensure files to edit exist.  Exit if any do not exist.
#

FAIL=false
for FILE in \
	/etc/rc.boot \
	/etc/rc.local \
	/sys/conf.common/files.cmn \
	/sys/sun/conf.c
do
	if [ ! -f $TOP_DIR$FILE ] ; then
		echo Installation error: file $TOP_DIR$FILE does not exist.
		FAIL=true
	fi
done
$FAIL && exit 1

#
# Execute the various scripts.
#

Execute edit_files.cmn.sh

Execute edit_conf.c.sh

Execute edit_rc.boot.sh

Execute edit_rc.local.sh

Execute edit_config.sh

Execute edit_MAKEDEV.ne.sh

exit $STATUS
