#!/bin/sh
#
# @(#)edit_conf.c.sh	1.2 93/01/19	Sun Microsystems Computer Corporation
#	From 1.7 8/11/92 Interphase
#
############################################################################
# This code is copyright 1991 by Interphase Corporation.		   #
# All rights reserved.							   #
#									   #
# This code contains confidential information and trade secrets of	   #
# Interphase Corporation which shall not be reproduced or		   #
# transferred to other programs or disclosed to others or used for	   #
# manufacturing or any other purpose without prior written permission of   #
# Interphase Corporation.  Use of copyright notice is precautionary        #
# and does not imply publication or intent thereof.			   #
############################################################################
#
#
# from conf.c.nc.sh	1.12 2/12/91 Interphase
#

Error () {
	fmt -79 <<- EOF
	
	$*
	
	EOF
	exit 1
}

PATH=/usr/bin:/usr/ucb:/usr/etc:$PATH ; export PATH
DIR=${PROTO}/sys/sun
FILE=conf.c
SUB_DIR=SNC
ORIG=$SUB_DIR/$FILE.presnc
FULLNAME="$ROOT_DIR$DIR/$FILE"

###################################################################
# Copy the modification scripts to SNC directory
###################################################################
if [ ! -d $ROOT_DIR$DIR/$SUB_DIR ] ; then
	mkdir $ROOT_DIR$DIR/$SUB_DIR > /dev/null 2>&1
fi
if [ -d SNC ] ; then
	source=.
else
	source=../_install
fi
cp -p $source/SNC/conf.c.add.nc.a $ROOT_DIR$DIR/$SUB_DIR/conf.c.add.nc.a
cp -p $source/SNC/conf.c.add.nc.b $ROOT_DIR$DIR/$SUB_DIR/conf.c.add.nc.b

cd $ROOT_DIR$DIR

###################################################################
# Check that the file exists and has not already been modified for NC
###################################################################

if [ -f $FILE ] ; then
	if grep -sw Interphase $FILE || grep -sw neopen $FILE ; then
		echo $FULLNAME has already been modified \
		     for the $PRODUCT.  Skipping the edit.
		exit 0
	fi
fi

###################################################################
# Ensure original gets restored if we're interrupted
###################################################################

if [ -f $FILE ] ; then
	if [ ! -f $ORIG ] ; then
		cp -p $FILE $ORIG
	fi
	mv -f $FILE $FILE.copy
elif [ -f $ORIG ] ; then
	cp -p $ORIG $FILE.copy
else
	Error Can not edit $FULLNAME -- file does not exist.
fi

ORIG=$FILE.copy
trap "mv -f $ORIG $FILE ; exit" 2 3 6 15

###################################################################
# Check that original file contains the key strings.
###################################################################

if grep -s "^${OWS}struct${WS}bdevsw${WS}bdevsw\[\]${WS}=" $ORIG &&
   grep -s "^${OWS}struct${WS}cdevsw${WS}cdevsw\[\]${WS}=" $ORIG &&
   [ "`grep -c '^};$' $ORIG`" -eq "2" ]
then
	: OK
else
	trap '' 2 3 6 15
	mv -f $ORIG $FILE
	Error Cannot edit $FULLNAME -- a required pattern \
	'(either' '"^struct bdevsw bdevsw="' or \
	'"^struct bdevsw bdevsw=")' \
	is missing. "

"	This probably indicates that $FULLNAME has been edited beyond \
	the recognition of this script.  Please see the SNC Installation \
	Manual for instructions on manual editing.
fi

###################################################################
# Get some useful numbers from current copy of conf.c.
###################################################################

# Get line number of the bdevsw line and subtract 1.
lineBdev=`grep -n "^${OWS}struct${WS}bdevsw${WS}bdevsw\[\]${WS}=" $ORIG | \
  awk -F: '{print $1}'`
bdevPrev=`expr $lineBdev - 1`

# Get line number of the bottom of the cdevsw array and subtract 1.
lineCdev=`grep -n '^};$' $ORIG | tail -1 | awk -F: '{print $1}'`
cdevPrev=`expr $lineCdev - 1`

# Get the device number used in the .add file.
# Thus even if the .add file has the wrong number, we use the right one.
devOmni=`sed -n -e "s/^.*\/\*\(.*\)*\/$/\1/p" $SUB_DIR/conf.c.add.nc.b | tail -1`

# Get the last number in comments and add 1.  This is the
# new high device number.
devHigh=`sed -n \
  -e "/^${OWS}struct${WS}cdevsw/,\$ s/^.*\/\*\([0-9][0-9]*\)\*\/$/\1/p" \
  $ORIG | tail -1`
devHigh=`expr $devHigh + 1`

# Save the new device number in a file for later use.  Make sure file is in
# a directory which isn't cleared at boot time.
echo $devHigh > /usr/tmp/devHigh.snc

# Find out if a comma exists after last structure in cdevsw[] structure "},"
# If not we must add a comma before adding our fields to cdevsw[]
#
comma=`sed -ne '/^struct.*cdevsw/,/^};$/p' $ORIG |  awk '/},[ 	]*$/ { addcomma = "" }
/}[ 	]*$/ { addcomma = "," }
END { print addcomma }' `

###################################################################
# Perform the edit
###################################################################

echo Editing $FULLNAME
head -$bdevPrev $ORIG > $FILE
echo '' >> $FILE
sed -e "/^###${WS}@(#)/p" -e '/^###/d' $SUB_DIR/conf.c.add.nc.a >> $FILE
echo '' >> $FILE
sed -n -e "$lineBdev,$cdevPrev p" $ORIG >> $FILE
echo $comma >> $FILE 
sed -e "s/\/\*${devOmni}\*\//\/*${devHigh}*\//" \
    -e "/^###${WS}@(#)/p" -e '/^###/d' $SUB_DIR/conf.c.add.nc.b >> $FILE
tail +$lineCdev $ORIG >> $FILE

trap 2 3 6 15
rm -f $ORIG
exit 0
