#!/bin/sh
#
#	@(#)edit_rc.boot.sh	1.1 93/01/14 Copyright (C) 1992  Sun Microsystems, Inc

Error () {
	fmt -79 <<- EOF
	
	$*
	
	Manual editing is required.
	
	EOF
	exit 1
}

DIR=/etc
FILE=rc.boot
ORIG=$FILE.presnc
FULLNAME="$TOP_DIR$DIR/$FILE"

cd $TOP_DIR$DIR

###################################################################
# Check that file exists and has not been modified already.
###################################################################

if [ ! -f $FILE ] ; then
	Error Cannot edit $FULLNAME -- file does not exist.
elif grep -sw ne.dwnld $FILE && grep -sw neload $FILE ; then
	echo $FILE has already been modified for $PRODUCT.
	exit 0
fi
if [ ! -f $ORIG ] ; then
	cp -p $FILE $ORIG
fi

###################################################################
# Check that original file contains the key string.
###################################################################

if grep -s "^${OWS}"'interface_names="`shcat' $FILE ; then
	: OK
else
	Error Cannot edit $FULLNAME -- the required pattern \
		'"^interface_names="`shcat"' is missing.  '

'		This probably indicates that $FULLNAME has been edited \
		beyond the recognition of this script.  Please see the \
		SNC Installation Manual for instructions on manual editing.
fi

###################################################################
# Ensure original gets restored if we're interrupted.
###################################################################

if [ -f $FILE ] ; then
	mv -f $FILE $FILE.copy
else
	cp -p $ORIG $FILE.copy
fi
ORIG=$FILE.copy
trap "mv -f $ORIG $FILE ; exit" 2 3 6 15

###################################################################
# Calculate number of lines to precede and follow SNC additions.
###################################################################

# Locate the key line and get its line number.
num=`grep -n "^${OWS}"'interface_names="\`shcat' $ORIG | awk -F: '{print $1}'`

# Find the line number of the last non-comment line preceding the key line.
# This is so the line setting interface_names won't be separated from its
# comment lines.
num=`head -$num $ORIG | grep -v -n '^[ 	]*#' | tail -2 | \
  awk -F: '{print $1;exit}'`

###################################################################
# Perform the edit.
###################################################################

echo Editing $FULLNAME
head -$num $ORIG > $FILE
sed -e '/^###/d' ${INSTALL_DIR}/SNC/rc.boot.add.nc.a >> $FILE
tail +`expr $num + 1` $ORIG >> $FILE

trap 2 3 6 15
rm -f $ORIG
exit 0
