#!/bin/sh
#
#	@(#)edit_rc.local.sh	1.1 93/01/14 Copyright (C) 1992  Sun Microsystems, Inc

Error () {
	fmt -79 <<- EOF
	
	$*
	
	EOF
	exit 1
}

DIR=/etc
FILE=rc.local
ORIG=$FILE.presnc
FULLNAME="$TOP_DIR$DIR/$FILE"

cd $TOP_DIR$DIR

###################################################################
# Check that file exists and has not been SNC-fied.
###################################################################

if [ ! -f $FILE ] ; then
	if [ -f $ORIG ] ; then
		cp -p $ORIG $FILE
	else
		Error Cannot edit $FULLNAME -- file does not exist.
	fi
fi

if grep -s SNC $FILE && grep -s sncnet $FILE
then
	echo $FILE has already been modified for $PRODUCT.
	exit 0
fi

###################################################################
# Check that original file contains the key strings.
###################################################################

if grep -s '^PATH=' $FILE
then
	: OK
else
	Error Cannot edit $FULLNAME -- the required pattern '"^PATH="' \
	is missing. \
 	This probably indicates that $FULLNAME has been edited beyond \
	the recognition of this script.  Please see the SNC Installation \
	Manual for instructions on manual editing.
fi

###################################################################
# Ensure original gets restored if we're interrupted.
###################################################################

if [ ! -f $ORIG ] ; then
	cp -p $FILE $ORIG
fi
mv -f $FILE $FILE.copy
ORIG=$FILE.copy
trap "mv -f $ORIG $FILE ; rm -f rc.local.?.tmp ; exit" 2 3 6 15

###################################################################
# Perform the edit.
###################################################################

echo Editing $FULLNAME
# Next two sed's remove the installation instructions from the
# temporary copies of the .add files prior to adding them to the
# destination file.
sed -e "/^###${WS}@(#)/p" \
    -e '/^###/d' ${INSTALL_DIR}/SNC/rc.local.add.nc.a > rc.local.a.tmp
sed -e "/^###${WS}@(#)/p" \
    -e '/^###/d' ${INSTALL_DIR}/SNC/rc.local.add.nc.b > rc.local.b.tmp
sed -e "
/^PATH=/ {
r rc.local.a.tmp
}
/^${OWS}nfsd${WS}[0-9]*.*echo${WS}*/ {
r rc.local.b.tmp
}
" $ORIG > $FILE

trap 2 3 6 15
rm -f $ORIG rc.local.?.tmp
exit 0
